# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/ejb3/jboss-ejb3-context/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion %{version}

Name:           jboss-ejb3-context
Version:        0.1.1
Release:        0.6%{?dist}
Epoch:          0
Summary:        JBoss EJB 3 Context Requirements
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# git clone -q -n http://github.com/wolfc/jboss-ejb3-context.git && mv jboss-ejb3-context jboss-ejb3-context-0.1.1 && cd jboss-ejb3-context-0.1.1 && git checkout -q jboss-ejb3-context-0.1.1 && cd ..
# tar cjf jboss-ejb3-context-0.1.1.tar.bz2 jboss-ejb3-context-0.1.1
Source0:        jboss-ejb3-context-0.1.1.tar.bz2
Source1:        jboss-ejb3-context-jpp-depmap.xml
Source2:        jboss-ejb3-context-settings.xml
Source3:        jboss-ejb3-context-component-info.xml
Patch0:         jboss-ejb3-context-pom.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
%if 0
Requires:       jboss-parent >= 0:4
%endif
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jakarta-commons-codec
BuildRequires:  jboss-javaee >= 0:5.0.1
BuildRequires:  jboss-parent >= 0:4
# FIXME: for org.jboss.javaee:jboss-ejb-api:jar:3.0.0.GA
BuildRequires:  jbossws >= 0:3.0.4
BuildRequires:  jbossws-parent
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  junit4 >= 0:4.4
BuildRequires:	qdox
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:	maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-enforcer-rule-api
BuildRequires:	maven-site-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss EJB 3 Context Requirements.

%package base
Summary:        JBoss EJB 3 Context Base
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       jboss-ejb-3.0-api
BuildRequires:  jboss-ejb-3.0-api

%description base
%{summary}.

%package naming
Summary:        JBoss EJB 3 Context Naming
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-base = %{epoch}:%{version}-%{release}
# XXX: 2.2.17.GA
Requires:       jboss-common-core >= 0:2.2.16
# XXX: 2.2.17.GA
BuildRequires:  jboss-common-core >= 0:2.2.16
# XXX: 5.0.4.GA
BuildRequires:  jboss-naming >= 0:5.0.3

%description naming
%{summary}.

%package javadoc
Summary:        Javadoc for JBoss EJB 3 Context
Group:          Development/Java

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p0 -b .sav0
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        deploy javadoc:aggregate

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p base/target/jboss-ejb3-context-base-%{version}.jar %{buildroot}%{_javadir}/%{name}-base-%{version}.jar
cp -p base/target/jboss-ejb3-context-base-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}-base-sources-%{version}.jar
cp -p naming/target/jboss-ejb3-context-naming-%{version}.jar %{buildroot}%{_javadir}/%{name}-naming-%{version}.jar
cp -p naming/target/jboss-ejb3-context-naming-%{version}-sources.jar %{buildroot}%{_javadir}/%{name}-naming-sources-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ejb3.context jboss-ejb3-context %{namedversion} JPP %{name}
cp -p base/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-base.pom
%add_to_maven_depmap org.jboss.ejb3.context jboss-ejb3-context-base %{namedversion} JPP %{name}-base
cp -p naming/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-naming.pom
%add_to_maven_depmap org.jboss.ejb3.context jboss-ejb3-context-naming %{namedversion} JPP %{name}-naming

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}
#mkdir -p %{buildroot}%{_javadocdir}/%{name}-base-%{version}
#cp -pr base/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-base-%{version}
#ln -s %{name}-base-%{version} %{buildroot}%{_javadocdir}/%{name}-base
#mkdir -p %{buildroot}%{_javadocdir}/%{name}-naming-%{version}
#cp -pr naming/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-naming-%{version}
#ln -s %{name}-naming-%{version} %{buildroot}%{_javadocdir}/%{name}-naming

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
mkdir -p %{buildroot}%{repodir}
mkdir -p %{buildroot}%{repodirlib}
install -p -m 755 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
mkdir -p %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/jboss-ejb3-context.pom
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-base.pom %{buildroot}%{repodirlib}/jboss-ejb3-context-base.pom
cp -p %{buildroot}%{_javadir}/%{name}-base-%{version}.jar %{buildroot}%{repodirlib}/jboss-ejb3-context-base.jar
cp -p %{buildroot}%{_javadir}/%{name}-base-sources-%{version}.jar %{buildroot}%{repodirlib}/%{name}-base-sources.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-naming.pom %{buildroot}%{repodirlib}/jboss-ejb3-context-naming.pom
cp -p %{buildroot}%{_javadir}/%{name}-naming-%{version}.jar %{buildroot}%{repodirlib}/jboss-ejb3-context-naming.jar
cp -p %{buildroot}%{_javadir}/%{name}-naming-sources-%{version}.jar %{buildroot}%{repodirlib}/jboss-ejb3-context-naming-sources.jar
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files base
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-base-%{version}.jar
%{_javadir}*/%{name}-base.jar
%{_javadir}*/%{name}-base-sources-%{version}.jar
%{_javadir}*/%{name}-base-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}-base.pom

%files naming
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-naming-%{version}.jar
%{_javadir}*/%{name}-naming.jar
%{_javadir}*/%{name}-naming-sources-%{version}.jar
%{_javadir}*/%{name}-naming-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}-naming.pom

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Jan 17 2011 Martha Benitez <mbenitez@redhat.com> - 0:0.1.1-0.6
- Rebuild for MEAD

* Tue Nov 16 2010 Martha Benitez <mbenitez@redhat.com> - 0:0.1.1-0.5
- Build with maven 2.2.1
- Consolidate javadoc base and naming sub-packages in one sub-package
- Change BR maven-release to maven-release-plugin
- Add BR jakarta-commons-codec, qdox

* Thu Jun 03 2010 Martha Benitez <mbenitez@redhat.com> 0:0.1.1-0.4
- Add base pom.xml file to repolib

* Wed Jun 02 2010 David Walluck <dwalluck@redhat.com> 0:0.1.1-0.3
- fix depmap entries

* Wed Jun 02 2010 David Walluck <dwalluck@redhat.com> 0:0.1.1-0.2
- fix depmap entries

* Fri May 28 2010 David Walluck <dwalluck@redhat.com> 0:0.1.1-0.1
- 0.1.1
